From 3fbcf4aa7efe9b08b9dc1b3cd227858a47bb9532 Mon Sep 17 00:00:00 2001
From: Alexander Brown <drjkl@comfy.org>
Date: Thu, 4 Sep 2025 22:29:44 -0700
Subject: [PATCH 50/77] knip: YOLO pass, all the unused exports enabled, YAGNI
 for the rest (#5313)

* knip: Enable unusedBinaries, add two exceptions

* knip: YOLO pass, all the unused exports enabled.
Paired with @christian-byrne to allow for some special cases to remain with custom knip ignore tags.

* knip: remove post-rebase
---
 knip.config.ts                                |  20 +--
 src/composables/useTemplateFiltering.ts       |   3 +-
 src/constants/serverConfig.ts                 |  27 ----
 src/extensions/core/load3d/interfaces.ts      |   9 --
 src/extensions/core/widgetInputs.ts           |   1 +
 src/lib/litegraph/src/draw.ts                 |   9 +-
 src/lib/litegraph/src/interfaces.ts           |   3 -
 src/lib/litegraph/src/litegraph.ts            |  13 +-
 src/lib/litegraph/src/node/slotUtils.ts       |   4 -
 src/lib/litegraph/src/types/events.ts         |   3 -
 src/lib/litegraph/src/types/globalEnums.ts    |   3 -
 src/lib/litegraph/src/types/serialisation.ts  |  14 --
 src/lib/litegraph/src/utils/collections.ts    |  16 +-
 src/lib/litegraph/src/widgets/widgetMap.ts    |  47 ------
 .../subgraph/fixtures/subgraphFixtures.ts     | 137 ------------------
 .../test/subgraph/fixtures/subgraphHelpers.ts | 104 -------------
 src/schemas/apiSchema.ts                      |  13 --
 src/schemas/comfyWorkflowSchema.ts            |   3 -
 src/schemas/nodeDef/nodeDefSchemaV2.ts        |   2 -
 src/schemas/nodeDefSchema.ts                  |  27 ----
 src/schemas/signInSchema.ts                   |   4 -
 src/scripts/domWidget.ts                      |  14 --
 src/scripts/utils.ts                          |   2 +
 src/types/algoliaTypes.ts                     |  14 +-
 src/types/comfyManagerTypes.ts                |  37 -----
 src/types/conflictDetectionTypes.ts           |  19 ---
 src/types/searchBoxTypes.ts                   |   6 -
 src/types/serverArgs.ts                       |   9 --
 src/types/settingTypes.ts                     |   7 -
 src/utils/formatUtil.ts                       |  46 ------
 src/utils/nodeDefUtil.ts                      |   9 --
 src/utils/versionUtil.ts                      |  28 ----
 .../core/__snapshots__/litegraph.test.ts.snap |  11 +-
 .../subgraph/fixtures/subgraphFixtures.ts     | 137 ------------------
 .../subgraph/fixtures/subgraphHelpers.ts      | 104 -------------
 35 files changed, 22 insertions(+), 883 deletions(-)

diff --git a/knip.config.ts b/knip.config.ts
index c691f3572..ca98c8f2a 100644
--- a/knip.config.ts
+++ b/knip.config.ts
@@ -16,6 +16,7 @@ const config: KnipConfig = {
     'tests-ui/**/*.{js,ts,vue}',
     '*.{js,ts,mts}'
   ],
+  ignoreBinaries: ['only-allow', 'openapi-typescript'],
   ignoreDependencies: [
     '@primeuix/forms',
     '@primeuix/styled',
@@ -59,7 +60,11 @@ const config: KnipConfig = {
     'src/components/button/TextButton.vue',
     'src/components/card/CardTitle.vue',
     'src/components/card/CardDescription.vue',
-    'src/components/input/SingleSelect.vue'
+    'src/components/input/SingleSelect.vue',
+    // Used by a custom node (that should move off of this)
+    'src/scripts/ui/components/splitButton.ts',
+    // Generated file: openapi
+    'src/types/comfyRegistryTypes.ts'
   ],
   ignoreExportsUsedInFile: true,
   // Vue-specific configuration
@@ -68,15 +73,12 @@ const config: KnipConfig = {
   // Only check for unused files, disable all other rules
   // TODO: Gradually enable other rules - see https://github.com/Comfy-Org/ComfyUI_frontend/issues/4888
   rules: {
-    binaries: 'off',
-    classMembers: 'off',
-    duplicates: 'off',
-    enumMembers: 'off',
-    exports: 'off',
-    nsExports: 'off',
-    nsTypes: 'off',
-    types: 'off'
+    classMembers: 'off'
   },
+  tags: [
+    '-knipIgnoreUnusedButUsedByCustomNodes',
+    '-knipIgnoreUnusedButUsedByVueNodesBranch'
+  ],
   // Include dependencies analysis
   includeEntryExports: true
 }
diff --git a/src/composables/useTemplateFiltering.ts b/src/composables/useTemplateFiltering.ts
index 14e5c6768..6bf0b53a2 100644
--- a/src/composables/useTemplateFiltering.ts
+++ b/src/composables/useTemplateFiltering.ts
@@ -2,7 +2,8 @@ import { type Ref, computed, ref } from 'vue'
 
 import type { TemplateInfo } from '@/types/workflowTemplateTypes'
 
-export interface TemplateFilterOptions {
+// @ts-expect-error unused (To be used later?)
+interface TemplateFilterOptions {
   searchQuery?: string
 }
 
diff --git a/src/constants/serverConfig.ts b/src/constants/serverConfig.ts
index 2f04e4cf3..45991f737 100644
--- a/src/constants/serverConfig.ts
+++ b/src/constants/serverConfig.ts
@@ -1,5 +1,4 @@
 import {
-  AutoLaunch,
   CrossAttentionMethod,
   CudaMalloc,
   FloatingPointPrecision,
@@ -20,32 +19,6 @@ export interface ServerConfig<T> extends FormItem {
   getValue?: (value: T) => Record<string, ServerConfigValue>
 }
 
-export const WEB_ONLY_CONFIG_ITEMS: ServerConfig<any>[] = [
-  // Launch behavior
-  {
-    id: 'auto-launch',
-    name: 'Automatically opens in the browser on startup',
-    category: ['Launch'],
-    type: 'combo',
-    options: Object.values(AutoLaunch),
-    defaultValue: AutoLaunch.Auto,
-    getValue: (value: AutoLaunch) => {
-      switch (value) {
-        case AutoLaunch.Auto:
-          return {}
-        case AutoLaunch.Enable:
-          return {
-            ['auto-launch']: true
-          }
-        case AutoLaunch.Disable:
-          return {
-            ['disable-auto-launch']: true
-          }
-      }
-    }
-  }
-]
-
 export const SERVER_CONFIG_ITEMS: ServerConfig<any>[] = [
   // Network settings
   {
diff --git a/src/extensions/core/load3d/interfaces.ts b/src/extensions/core/load3d/interfaces.ts
index 51247a8a3..fa05ce2b0 100644
--- a/src/extensions/core/load3d/interfaces.ts
+++ b/src/extensions/core/load3d/interfaces.ts
@@ -185,12 +185,3 @@ export interface LoaderManagerInterface {
   dispose(): void
   loadModel(url: string, originalFileName?: string): Promise<void>
 }
-
-export interface RecordingManagerInterface extends BaseManager {
-  startRecording(): Promise<void>
-  stopRecording(): void
-  hasRecording(): boolean
-  getRecordingDuration(): number
-  exportRecording(filename?: string): void
-  clearRecording(): void
-}
diff --git a/src/extensions/core/widgetInputs.ts b/src/extensions/core/widgetInputs.ts
index bc0725627..46954430f 100644
--- a/src/extensions/core/widgetInputs.ts
+++ b/src/extensions/core/widgetInputs.ts
@@ -422,6 +422,7 @@ function getConfig(this: LGraphNode, widgetName: string) {
  * @param node The node to convert the widget to an input slot for.
  * @param widget The widget to convert to an input slot.
  * @returns The input slot that was converted from the widget or undefined if the widget is not found.
+ * @knipIgnoreUnusedButUsedByCustomNodes
  */
 export function convertToInput(
   node: LGraphNode,
diff --git a/src/lib/litegraph/src/draw.ts b/src/lib/litegraph/src/draw.ts
index 756c60db1..b335f3f81 100644
--- a/src/lib/litegraph/src/draw.ts
+++ b/src/lib/litegraph/src/draw.ts
@@ -1,7 +1,7 @@
 import type { Rectangle } from './infrastructure/Rectangle'
 import type { CanvasColour, Rect } from './interfaces'
 import { LiteGraph } from './litegraph'
-import { LinkDirection, RenderShape, TitleMode } from './types/globalEnums'
+import { RenderShape, TitleMode } from './types/globalEnums'
 
 const ELLIPSIS = '\u2026'
 const TWO_DOT_LEADER = '\u2025'
@@ -22,12 +22,7 @@ export enum SlotShape {
 }
 
 /** @see LinkDirection */
-export enum SlotDirection {
-  Up = LinkDirection.UP,
-  Right = LinkDirection.RIGHT,
-  Down = LinkDirection.DOWN,
-  Left = LinkDirection.LEFT
-}
+export enum SlotDirection {}
 
 export enum LabelPosition {
   Left = 'left',
diff --git a/src/lib/litegraph/src/interfaces.ts b/src/lib/litegraph/src/interfaces.ts
index 0a34133f9..0abbf313b 100644
--- a/src/lib/litegraph/src/interfaces.ts
+++ b/src/lib/litegraph/src/interfaces.ts
@@ -278,9 +278,6 @@ export type KeysOfType<T, Match> = Exclude<
   undefined
 >
 
-/** A new type that contains only the properties of T that are of type Match */
-export type PickByType<T, Match> = { [P in keyof T]: Extract<T[P], Match> }
-
 /** The names of all (optional) methods and functions in T */
 export type MethodNames<T> = KeysOfType<T, ((...args: any) => any) | undefined>
 
diff --git a/src/lib/litegraph/src/litegraph.ts b/src/lib/litegraph/src/litegraph.ts
index 5be28a413..fd1d1a31a 100644
--- a/src/lib/litegraph/src/litegraph.ts
+++ b/src/lib/litegraph/src/litegraph.ts
@@ -2,7 +2,7 @@ import type { ContextMenu } from './ContextMenu'
 import type { LGraphNode } from './LGraphNode'
 import { LiteGraphGlobal } from './LiteGraphGlobal'
 import type { ConnectingLink, Point } from './interfaces'
-import type { IContextMenuOptions, INodeSlot, Size } from './interfaces'
+import type { IContextMenuOptions, Size } from './interfaces'
 import { loadPolyfills } from './polyfills'
 import type { CanvasEventDetail } from './types/events'
 import type { RenderShape, TitleMode } from './types/globalEnums'
@@ -22,8 +22,6 @@ loadPolyfills()
 // Definitions by: NateScarlet <https://github.com/NateScarlet>
 /** @deprecated Use {@link Point} instead. */
 export type Vector2 = Point
-/** @deprecated Use {@link Rect} instead. */
-export type Vector4 = [number, number, number, number]
 
 export interface IContextMenuItem {
   content: string
@@ -46,14 +44,6 @@ export type ContextMenuEventListener = (
   node: LGraphNode
 ) => boolean | void
 
-export interface LinkReleaseContext {
-  node_to?: LGraphNode
-  node_from?: LGraphNode
-  slot_from: INodeSlot
-  type_filter_in?: string
-  type_filter_out?: string
-}
-
 export interface LinkReleaseContextExtended {
   links: ConnectingLink[]
 }
@@ -117,7 +107,6 @@ export type {
   LinkNetwork,
   LinkSegment,
   MethodNames,
-  PickByType,
   Point,
   Positionable,
   ReadonlyLinkNetwork,
diff --git a/src/lib/litegraph/src/node/slotUtils.ts b/src/lib/litegraph/src/node/slotUtils.ts
index 3d97ca142..e0eda79c8 100644
--- a/src/lib/litegraph/src/node/slotUtils.ts
+++ b/src/lib/litegraph/src/node/slotUtils.ts
@@ -84,10 +84,6 @@ export function isINodeInputSlot(slot: INodeSlot): slot is INodeInputSlot {
   return 'link' in slot
 }
 
-export function isINodeOutputSlot(slot: INodeSlot): slot is INodeOutputSlot {
-  return 'links' in slot
-}
-
 /**
  * Type guard: Whether this input slot is attached to a widget.
  * @param slot The slot to check.
diff --git a/src/lib/litegraph/src/types/events.ts b/src/lib/litegraph/src/types/events.ts
index 912cc89ff..acbb89043 100644
--- a/src/lib/litegraph/src/types/events.ts
+++ b/src/lib/litegraph/src/types/events.ts
@@ -50,9 +50,6 @@ export interface CanvasMouseEvent
     Readonly<CanvasPointerExtensions>,
     LegacyMouseEvent {}
 
-/** DragEvent with canvasX/Y and deltaX/Y properties */
-export interface CanvasDragEvent extends DragEvent, CanvasPointerExtensions {}
-
 export type CanvasEventDetail =
   | GenericEventDetail
   | GroupDoubleClickEventDetail
diff --git a/src/lib/litegraph/src/types/globalEnums.ts b/src/lib/litegraph/src/types/globalEnums.ts
index 5e2afcadc..c955b8e1e 100644
--- a/src/lib/litegraph/src/types/globalEnums.ts
+++ b/src/lib/litegraph/src/types/globalEnums.ts
@@ -89,9 +89,6 @@ export enum LGraphEventMode {
 }
 
 export enum EaseFunction {
-  LINEAR = 'linear',
-  EASE_IN_QUAD = 'easeInQuad',
-  EASE_OUT_QUAD = 'easeOutQuad',
   EASE_IN_OUT_QUAD = 'easeInOutQuad'
 }
 
diff --git a/src/lib/litegraph/src/types/serialisation.ts b/src/lib/litegraph/src/types/serialisation.ts
index 46b4ad7cc..4b1bfed90 100644
--- a/src/lib/litegraph/src/types/serialisation.ts
+++ b/src/lib/litegraph/src/types/serialisation.ts
@@ -179,14 +179,6 @@ export interface ISerialisedGroup {
   flags?: IGraphGroupFlags
 }
 
-export type TClipboardLink = [
-  targetRelativeIndex: number,
-  originSlot: number,
-  nodeRelativeIndex: number,
-  targetSlot: number,
-  targetNodeId: NodeId
-]
-
 /** Items copied from the canvas */
 export interface ClipboardItems {
   nodes?: ISerialisedNode[]
@@ -196,12 +188,6 @@ export interface ClipboardItems {
   subgraphs?: ExportedSubgraph[]
 }
 
-/** @deprecated */
-export interface IClipboardContents {
-  nodes?: ISerialisedNode[]
-  links?: TClipboardLink[]
-}
-
 export interface SerialisableReroute {
   id: RerouteId
   parentId?: RerouteId
diff --git a/src/lib/litegraph/src/utils/collections.ts b/src/lib/litegraph/src/utils/collections.ts
index 85da38382..46eba75e0 100644
--- a/src/lib/litegraph/src/utils/collections.ts
+++ b/src/lib/litegraph/src/utils/collections.ts
@@ -1,8 +1,7 @@
 import { LGraphNode } from '@/lib/litegraph/src/LGraphNode'
-import type { LinkId } from '@/lib/litegraph/src/LLink'
 import { parseSlotTypes } from '@/lib/litegraph/src/strings'
 
-import type { ConnectingLink, ISlotType, Positionable } from '../interfaces'
+import type { ISlotType, Positionable } from '../interfaces'
 
 /**
  * Creates a flat set of all positionable items by recursively iterating through all child items.
@@ -45,19 +44,6 @@ export function findFirstNode(
   }
 }
 
-/** @returns `true` if the provided link ID is currently being dragged. */
-export function isDraggingLink(
-  linkId: LinkId,
-  connectingLinks: ConnectingLink[] | null | undefined
-): ConnectingLink | undefined {
-  if (connectingLinks == null) return
-
-  for (const connectingLink of connectingLinks) {
-    if (connectingLink.link == null) continue
-    if (linkId === connectingLink.link.id) return connectingLink
-  }
-}
-
 type FreeSlotResult<T extends { type: ISlotType }> =
   | { index: number; slot: T }
   | undefined
diff --git a/src/lib/litegraph/src/widgets/widgetMap.ts b/src/lib/litegraph/src/widgets/widgetMap.ts
index 87b8614e7..42a8f5663 100644
--- a/src/lib/litegraph/src/widgets/widgetMap.ts
+++ b/src/lib/litegraph/src/widgets/widgetMap.ts
@@ -1,14 +1,7 @@
 import type { LGraphNode } from '@/lib/litegraph/src/LGraphNode'
 import type {
   IBaseWidget,
-  IBooleanWidget,
-  IButtonWidget,
   IComboWidget,
-  ICustomWidget,
-  IKnobWidget,
-  INumericWidget,
-  ISliderWidget,
-  IStringWidget,
   IWidget,
   TWidgetType
 } from '@/lib/litegraph/src/types/widgets'
@@ -130,49 +123,9 @@ export function toConcreteWidget<TWidget extends IWidget | IBaseWidget>(
 
 // #region Type Guards
 
-/** Type guard: Narrow **from {@link IBaseWidget}** to {@link IButtonWidget}. */
-export function isButtonWidget(widget: IBaseWidget): widget is IButtonWidget {
-  return widget.type === 'button'
-}
-
-/** Type guard: Narrow **from {@link IBaseWidget}** to {@link IBooleanWidget}. */
-export function isBooleanWidget(widget: IBaseWidget): widget is IBooleanWidget {
-  return widget.type === 'toggle'
-}
-
-/** Type guard: Narrow **from {@link IBaseWidget}** to {@link ISliderWidget}. */
-export function isSliderWidget(widget: IBaseWidget): widget is ISliderWidget {
-  return widget.type === 'slider'
-}
-
-/** Type guard: Narrow **from {@link IBaseWidget}** to {@link IKnobWidget}. */
-export function isKnobWidget(widget: IBaseWidget): widget is IKnobWidget {
-  return widget.type === 'knob'
-}
-
 /** Type guard: Narrow **from {@link IBaseWidget}** to {@link IComboWidget}. */
 export function isComboWidget(widget: IBaseWidget): widget is IComboWidget {
   return widget.type === 'combo'
 }
 
-/** Type guard: Narrow **from {@link IBaseWidget}** to {@link INumericWidget}. */
-export function isNumberWidget(widget: IBaseWidget): widget is INumericWidget {
-  return widget.type === 'number'
-}
-
-/** Type guard: Narrow **from {@link IBaseWidget}** to {@link IStringWidget}. */
-export function isStringWidget(widget: IBaseWidget): widget is IStringWidget {
-  return widget.type === 'string'
-}
-
-/** Type guard: Narrow **from {@link IBaseWidget}** to {@link ITextWidget}. */
-export function isTextWidget(widget: IBaseWidget): widget is IStringWidget {
-  return widget.type === 'text'
-}
-
-/** Type guard: Narrow **from {@link IBaseWidget}** to {@link ICustomWidget}. */
-export function isCustomWidget(widget: IBaseWidget): widget is ICustomWidget {
-  return widget.type === 'custom'
-}
-
 // #endregion Type Guards
diff --git a/src/lib/litegraph/test/subgraph/fixtures/subgraphFixtures.ts b/src/lib/litegraph/test/subgraph/fixtures/subgraphFixtures.ts
index dcd6624a4..1c2d936ac 100644
--- a/src/lib/litegraph/test/subgraph/fixtures/subgraphFixtures.ts
+++ b/src/lib/litegraph/test/subgraph/fixtures/subgraphFixtures.ts
@@ -169,140 +169,3 @@ export const subgraphTest = test.extend<SubgraphFixtures>({
     capture.cleanup()
   }
 })
-
-/**
- * Fixtures that test edge cases and error conditions.
- * These may leave the system in an invalid state and should be used carefully.
- */
-export interface EdgeCaseFixtures {
-  /** Subgraph with circular references (for testing recursion detection) */
-  circularSubgraph: {
-    rootGraph: LGraph
-    subgraphA: Subgraph
-    subgraphB: Subgraph
-    nodeA: SubgraphNode
-    nodeB: SubgraphNode
-  }
-
-  /** Deeply nested subgraphs approaching the theoretical limit */
-  deeplyNestedSubgraph: ReturnType<typeof createNestedSubgraphs>
-
-  /** Subgraph with maximum inputs and outputs */
-  maxIOSubgraph: Subgraph
-}
-
-/**
- * Test with edge case fixtures. Use sparingly and with caution.
- * These tests may intentionally create invalid states.
- */
-export const edgeCaseTest = subgraphTest.extend<EdgeCaseFixtures>({
-  // @ts-expect-error TODO: Fix after merge - fixture use parameter type
-  // eslint-disable-next-line no-empty-pattern
-  circularSubgraph: async ({}, use: (value: unknown) => Promise<void>) => {
-    const rootGraph = new LGraph()
-
-    // Create two subgraphs that will reference each other
-    const subgraphA = createTestSubgraph({
-      name: 'Subgraph A',
-      inputs: [{ name: 'input', type: '*' }],
-      outputs: [{ name: 'output', type: '*' }]
-    })
-
-    const subgraphB = createTestSubgraph({
-      name: 'Subgraph B',
-      inputs: [{ name: 'input', type: '*' }],
-      outputs: [{ name: 'output', type: '*' }]
-    })
-
-    // Create instances (this doesn't create circular refs by itself)
-    const nodeA = createTestSubgraphNode(subgraphA, { pos: [100, 100] })
-    const nodeB = createTestSubgraphNode(subgraphB, { pos: [300, 100] })
-
-    // Add nodes to root graph
-    rootGraph.add(nodeA)
-    rootGraph.add(nodeB)
-
-    await use({
-      rootGraph,
-      subgraphA,
-      subgraphB,
-      nodeA,
-      nodeB
-    })
-  },
-
-  // @ts-expect-error TODO: Fix after merge - fixture use parameter type
-  // eslint-disable-next-line no-empty-pattern
-  deeplyNestedSubgraph: async ({}, use: (value: unknown) => Promise<void>) => {
-    // Create a very deep nesting structure (but not exceeding MAX_NESTED_SUBGRAPHS)
-    const nested = createNestedSubgraphs({
-      depth: 50, // Deep but reasonable
-      nodesPerLevel: 1,
-      inputsPerSubgraph: 1,
-      outputsPerSubgraph: 1
-    })
-
-    await use(nested)
-  },
-
-  // @ts-expect-error TODO: Fix after merge - fixture use parameter type
-  // eslint-disable-next-line no-empty-pattern
-  maxIOSubgraph: async ({}, use: (value: unknown) => Promise<void>) => {
-    // Create a subgraph with many inputs and outputs
-    const inputs = Array.from({ length: 20 }, (_, i) => ({
-      name: `input_${i}`,
-      type: i % 2 === 0 ? 'number' : ('string' as const)
-    }))
-
-    const outputs = Array.from({ length: 20 }, (_, i) => ({
-      name: `output_${i}`,
-      type: i % 2 === 0 ? 'number' : ('string' as const)
-    }))
-
-    const subgraph = createTestSubgraph({
-      name: 'Max IO Subgraph',
-      inputs,
-      outputs,
-      nodeCount: 10
-    })
-
-    await use(subgraph)
-  }
-})
-
-/**
- * Helper to verify fixture integrity.
- * Use this in tests to ensure fixtures are properly set up.
- */
-export function verifyFixtureIntegrity<T extends Record<string, unknown>>(
-  fixture: T,
-  expectedProperties: (keyof T)[]
-): void {
-  for (const prop of expectedProperties) {
-    if (!(prop in fixture)) {
-      throw new Error(`Fixture missing required property: ${String(prop)}`)
-    }
-    if (fixture[prop] === undefined || fixture[prop] === null) {
-      throw new Error(`Fixture property ${String(prop)} is null or undefined`)
-    }
-  }
-}
-
-/**
- * Creates a snapshot-friendly representation of a subgraph for testing.
- * Useful for serialization tests and regression detection.
- */
-export function createSubgraphSnapshot(subgraph: Subgraph) {
-  return {
-    id: subgraph.id,
-    name: subgraph.name,
-    inputCount: subgraph.inputs.length,
-    outputCount: subgraph.outputs.length,
-    nodeCount: subgraph.nodes.length,
-    linkCount: subgraph.links.size,
-    inputs: subgraph.inputs.map((i) => ({ name: i.name, type: i.type })),
-    outputs: subgraph.outputs.map((o) => ({ name: o.name, type: o.type })),
-    hasInputNode: !!subgraph.inputNode,
-    hasOutputNode: !!subgraph.outputNode
-  }
-}
diff --git a/src/lib/litegraph/test/subgraph/fixtures/subgraphHelpers.ts b/src/lib/litegraph/test/subgraph/fixtures/subgraphHelpers.ts
index fcf25ce7c..4a3bd6c11 100644
--- a/src/lib/litegraph/test/subgraph/fixtures/subgraphHelpers.ts
+++ b/src/lib/litegraph/test/subgraph/fixtures/subgraphHelpers.ts
@@ -382,76 +382,6 @@ export function createTestSubgraphData(
   }
 }
 
-/**
- * Creates a complex subgraph with multiple nodes and connections.
- * Useful for testing realistic scenarios.
- * @param nodeCount Number of internal nodes to create
- * @returns Complex subgraph data structure
- */
-export function createComplexSubgraphData(
-  nodeCount: number = 5
-): ExportedSubgraph {
-  const nodes = []
-  const links: Record<
-    string,
-    {
-      id: number
-      origin_id: number
-      origin_slot: number
-      target_id: number
-      target_slot: number
-      type: string
-    }
-  > = {}
-
-  // Create internal nodes
-  for (let i = 0; i < nodeCount; i++) {
-    nodes.push({
-      id: i + 1, // Start from 1 to avoid conflicts with IO nodes
-      type: 'basic/test',
-      pos: [100 + i * 150, 200],
-      size: [120, 60],
-      inputs: [{ name: 'in', type: '*', link: null }],
-      outputs: [{ name: 'out', type: '*', links: [] }],
-      properties: { value: i },
-      flags: {},
-      mode: 0
-    })
-  }
-
-  // Create some internal links
-  for (let i = 0; i < nodeCount - 1; i++) {
-    const linkId = i + 1
-    links[linkId] = {
-      id: linkId,
-      origin_id: i + 1,
-      origin_slot: 0,
-      target_id: i + 2,
-      target_slot: 0,
-      type: '*'
-    }
-  }
-
-  return createTestSubgraphData({
-    // @ts-expect-error TODO: Fix after merge - nodes parameter type
-    nodes,
-    // @ts-expect-error TODO: Fix after merge - links parameter type
-    links,
-    inputs: [
-      // @ts-expect-error TODO: Fix after merge - input object type
-      { name: 'input1', type: 'number', pos: [0, 0] },
-      // @ts-expect-error TODO: Fix after merge - input object type
-      { name: 'input2', type: 'string', pos: [0, 1] }
-    ],
-    outputs: [
-      // @ts-expect-error TODO: Fix after merge - output object type
-      { name: 'output1', type: 'number', pos: [0, 0] },
-      // @ts-expect-error TODO: Fix after merge - output object type
-      { name: 'output2', type: 'string', pos: [0, 1] }
-    ]
-  })
-}
-
 /**
  * Creates an event capture system for testing event sequences.
  * @param eventTarget The event target to monitor
@@ -493,39 +423,5 @@ export function createEventCapture<T = unknown>(
   }
 }
 
-/**
- * Utility to log subgraph structure for debugging tests.
- * @param subgraph The subgraph to inspect
- * @param label Optional label for the log output
- */
-export function logSubgraphStructure(
-  subgraph: Subgraph,
-  label: string = 'Subgraph'
-): void {
-  console.log(`\n=== ${label} Structure ===`)
-  console.log(`Name: ${subgraph.name}`)
-  console.log(`ID: ${subgraph.id}`)
-  console.log(`Inputs: ${subgraph.inputs.length}`)
-  console.log(`Outputs: ${subgraph.outputs.length}`)
-  console.log(`Nodes: ${subgraph.nodes.length}`)
-  console.log(`Links: ${subgraph.links.size}`)
-
-  if (subgraph.inputs.length > 0) {
-    console.log(
-      'Input details:',
-      subgraph.inputs.map((i) => ({ name: i.name, type: i.type }))
-    )
-  }
-
-  if (subgraph.outputs.length > 0) {
-    console.log(
-      'Output details:',
-      subgraph.outputs.map((o) => ({ name: o.name, type: o.type }))
-    )
-  }
-
-  console.log('========================\n')
-}
-
 // Re-export expect from vitest for convenience
 export { expect } from 'vitest'
diff --git a/src/schemas/apiSchema.ts b/src/schemas/apiSchema.ts
index 874449665..5c86ff00c 100644
--- a/src/schemas/apiSchema.ts
+++ b/src/schemas/apiSchema.ts
@@ -1,5 +1,4 @@
 import { z } from 'zod'
-import { fromZodError } from 'zod-validation-error'
 
 import { LinkMarkerShape } from '@/lib/litegraph/src/litegraph'
 import { colorPalettesSchema } from '@/schemas/colorPaletteSchema'
@@ -280,18 +279,6 @@ export type PendingTaskItem = z.infer<typeof zPendingTaskItem>
 export type HistoryTaskItem = z.infer<typeof zHistoryTaskItem>
 export type TaskItem = z.infer<typeof zTaskItem>
 
-export function validateTaskItem(taskItem: unknown) {
-  const result = zTaskItem.safeParse(taskItem)
-  if (!result.success) {
-    const zodError = fromZodError(result.error)
-    // TODO accept a callback to report error.
-    console.warn(
-      `Invalid TaskItem: ${JSON.stringify(taskItem)}\n${zodError.message}`
-    )
-  }
-  return result
-}
-
 const zEmbeddingsResponse = z.array(z.string())
 const zExtensionsResponse = z.array(z.string())
 const zError = z.object({
diff --git a/src/schemas/comfyWorkflowSchema.ts b/src/schemas/comfyWorkflowSchema.ts
index 70ebcd279..62be3392b 100644
--- a/src/schemas/comfyWorkflowSchema.ts
+++ b/src/schemas/comfyWorkflowSchema.ts
@@ -447,14 +447,11 @@ export const zSubgraphDefinition = zComfyWorkflow1
   .passthrough()
 
 export type ModelFile = z.infer<typeof zModelFile>
-export type NodeInput = z.infer<typeof zNodeInput>
-export type NodeOutput = z.infer<typeof zNodeOutput>
 export type ComfyLink = z.infer<typeof zComfyLink>
 export type ComfyLinkObject = z.infer<typeof zComfyLinkObject>
 export type ComfyNode = z.infer<typeof zComfyNode>
 export type Reroute = z.infer<typeof zReroute>
 export type WorkflowJSON04 = z.infer<typeof zComfyWorkflow>
-export type WorkflowJSON10 = z.infer<typeof zComfyWorkflow1>
 export type ComfyWorkflowJSON = z.infer<
   typeof zComfyWorkflow | typeof zComfyWorkflow1
 >
diff --git a/src/schemas/nodeDef/nodeDefSchemaV2.ts b/src/schemas/nodeDef/nodeDefSchemaV2.ts
index f94d7cc48..cb212fb99 100644
--- a/src/schemas/nodeDef/nodeDefSchemaV2.ts
+++ b/src/schemas/nodeDef/nodeDefSchemaV2.ts
@@ -214,9 +214,7 @@ export type StringInputSpec = z.infer<typeof zStringInputSpec>
 export type ComboInputSpec = z.infer<typeof zComboInputSpec>
 export type ColorInputSpec = z.infer<typeof zColorInputSpec>
 export type FileUploadInputSpec = z.infer<typeof zFileUploadInputSpec>
-export type ImageInputSpec = z.infer<typeof zImageInputSpec>
 export type ImageCompareInputSpec = z.infer<typeof zImageCompareInputSpec>
-export type MarkdownInputSpec = z.infer<typeof zMarkdownInputSpec>
 export type TreeSelectInputSpec = z.infer<typeof zTreeSelectInputSpec>
 export type MultiSelectInputSpec = z.infer<typeof zMultiSelectInputSpec>
 export type ChartInputSpec = z.infer<typeof zChartInputSpec>
diff --git a/src/schemas/nodeDefSchema.ts b/src/schemas/nodeDefSchema.ts
index 9370c9073..9d4c0b2e8 100644
--- a/src/schemas/nodeDefSchema.ts
+++ b/src/schemas/nodeDefSchema.ts
@@ -128,30 +128,12 @@ export function isFloatInputSpec(
   return inputSpec[0] === 'FLOAT'
 }
 
-export function isBooleanInputSpec(
-  inputSpec: InputSpec
-): inputSpec is BooleanInputSpec {
-  return inputSpec[0] === 'BOOLEAN'
-}
-
-export function isStringInputSpec(
-  inputSpec: InputSpec
-): inputSpec is StringInputSpec {
-  return inputSpec[0] === 'STRING'
-}
-
 export function isComboInputSpecV2(
   inputSpec: InputSpec
 ): inputSpec is ComboInputSpecV2 {
   return inputSpec[0] === 'COMBO'
 }
 
-export function isCustomInputSpec(
-  inputSpec: InputSpec
-): inputSpec is CustomInputSpec {
-  return typeof inputSpec[0] === 'string' && !excludedLiterals.has(inputSpec[0])
-}
-
 export function isComboInputSpec(
   inputSpec: InputSpec
 ): inputSpec is ComboInputSpec | ComboInputSpecV2 {
@@ -247,22 +229,13 @@ export type ComfyOutputTypesSpec = z.infer<typeof zComfyOutputTypesSpec>
 export type ComfyNodeDef = z.infer<typeof zComfyNodeDef>
 export type RemoteWidgetConfig = z.infer<typeof zRemoteWidgetConfig>
 
-// Input specs
-export type IntInputOptions = z.infer<typeof zIntInputOptions>
-export type FloatInputOptions = z.infer<typeof zFloatInputOptions>
-export type BooleanInputOptions = z.infer<typeof zBooleanInputOptions>
-export type StringInputOptions = z.infer<typeof zStringInputOptions>
 export type ComboInputOptions = z.infer<typeof zComboInputOptions>
-export type BaseInputOptions = z.infer<typeof zBaseInputOptions>
 export type NumericInputOptions = z.infer<typeof zNumericInputOptions>
 
 export type IntInputSpec = z.infer<typeof zIntInputSpec>
 export type FloatInputSpec = z.infer<typeof zFloatInputSpec>
-export type BooleanInputSpec = z.infer<typeof zBooleanInputSpec>
-export type StringInputSpec = z.infer<typeof zStringInputSpec>
 export type ComboInputSpec = z.infer<typeof zComboInputSpec>
 export type ComboInputSpecV2 = z.infer<typeof zComboInputSpecV2>
-export type CustomInputSpec = z.infer<typeof zCustomInputSpec>
 export type InputSpec = z.infer<typeof zInputSpec>
 
 export function validateComfyNodeDef(
diff --git a/src/schemas/signInSchema.ts b/src/schemas/signInSchema.ts
index 0e1e4905d..1e5a44198 100644
--- a/src/schemas/signInSchema.ts
+++ b/src/schemas/signInSchema.ts
@@ -10,8 +10,6 @@ export const apiKeySchema = z.object({
     .length(72, t('validation.length', { length: 72 }))
 })
 
-export type ApiKeyData = z.infer<typeof apiKeySchema>
-
 export const signInSchema = z.object({
   email: z
     .string()
@@ -42,8 +40,6 @@ export const updatePasswordSchema = passwordSchema.refine(
   }
 )
 
-export type UpdatePasswordData = z.infer<typeof updatePasswordSchema>
-
 export const signUpSchema = passwordSchema
   .extend({
     email: z
diff --git a/src/scripts/domWidget.ts b/src/scripts/domWidget.ts
index ea2158326..1b081facd 100644
--- a/src/scripts/domWidget.ts
+++ b/src/scripts/domWidget.ts
@@ -375,17 +375,3 @@ LGraphNode.prototype.addDOMWidget = function <
 
   return widget
 }
-
-/**
- * Prunes widgets that are no longer in the graph.
- * @param nodes The nodes to prune widgets for.
- */
-export const pruneWidgets = (nodes: LGraphNode[]) => {
-  const nodeSet = new Set(nodes)
-  const domWidgetStore = useDomWidgetStore()
-  for (const { widget } of domWidgetStore.widgetStates.values()) {
-    if (!nodeSet.has(widget.node)) {
-      domWidgetStore.unregisterWidget(widget.id)
-    }
-  }
-}
diff --git a/src/scripts/utils.ts b/src/scripts/utils.ts
index 778b712d9..59556523b 100644
--- a/src/scripts/utils.ts
+++ b/src/scripts/utils.ts
@@ -17,6 +17,7 @@ export function clone<T>(obj: T): T {
 }
 
 /**
+ * @knipIgnoreUnusedButUsedByCustomNodes
  * @deprecated Use `applyTextReplacements` from `@/utils/searchAndReplace` instead
  * There are external callers to this function, so we need to keep it for now
  */
@@ -24,6 +25,7 @@ export function applyTextReplacements(app: ComfyApp, value: string): string {
   return _applyTextReplacements(app.graph, value)
 }
 
+/** @knipIgnoreUnusedButUsedByCustomNodes */
 export async function addStylesheet(
   urlOrFile: string,
   relativeTo?: string
